=== modified file 'Makefile'
--- Makefile	2009-11-19 18:31:28 +0000
+++ Makefile	2009-11-01 00:10:28 +0000
@@ -17,6 +17,7 @@
 # If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
 FORTIFY += -fPIE
+LINK_FORTIFY_LD += -fPIE
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage

=== modified file 'TODO'
--- TODO	2010-08-22 13:34:42 +0000
+++ TODO	2009-11-01 00:10:28 +0000
@@ -1,7 +1,5 @@
 -*- org -*-
 
-* _attribute_((nonnull))
-
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
@@ -10,101 +8,85 @@
 *** A closed connection during the TLS handshake
 *** A TCP timeout
 ** TODO [#B] Use capabilities instead of seteuid().
-** TODO [#A] Retry --connect forever
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
 
 * usplash
-** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
 
 * askpass-fifo
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
-** TODO [#B] lock stdin (with flock()?)
+** TODO use error() instead of perror()
+** TODO lock stdin (with flock()?)
 
-* TODO [#B] passdev
+* TODO passdev
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
-** kernel command line option for debug info
-** TODO [#B] use error() instead of perror()
-** TODO [$B] Use openat() and readdir64()
-   http://udrepper.livejournal.com/19395.html
+** TODO use error() instead of perror()
 
 * mandos (server)
-** TODO [#B] Log level							  :BUGS:
-** TODO Persistent state						  :BUGS:
-   /var/lib/mandos/*
-*** TODO /etc/mandos/clients.d/*.conf
-    Watch this directory and add/remove/update clients?
-** TODO [#C] config for TXT record
-** TODO Log level option
-   syslogger.setLevel(logging.WARNING)
-   + SetLogLevel D-Bus call
-** TODO Implement --foreground						  :BUGS:
+** TODO [#B] Log level				:BUGS:
+** TODO /etc/mandos/clients.d/*.conf
+   Watch this directory and add/remove/update clients?
+** TODO config for TXT record
+** TODO [#B] Run-time communication with server :BUGS:
+   Probably using D-Bus
+*** Client class
+*** Main server
+    + SetLogLevel
+      syslogger.setLevel(logging.WARNING)
+    + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
+** TODO Implement --foreground			:BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages				  :BUGS:
+** TODO Date+time on console log messages	:BUGS:
    Is this the default?
-** TODO [#C] DBusServiceObjectUsingSuper
-** TODO [#B] Global enable/disable flag
-** TODO [#B] By-client countdown on secrets given
-** TODO [#B] Fix problem with fsck taking a really long time
+** TODO DBusServiceObjectUsingSuper
+** TODO Global enable/disable flag
+** TODO By-client countdown on secrets given
+** TODO Fix problem with fsck taking a really long time
    Whenever a client successfully gets a secret it could get a
    one-time timeout boost to allow for an fsck-incurred delay
-** TODO [#A] Delay before client receives key
+** TODO Delay before client receives key
    This would give an operator opportunity to cancel the request if
    desired.
-** TODO [#A] Client manual approval mode
+** TODO Client manual approval mode
    A client needs manual approval on the server before it gets the
    secret
-** TODO [#B] Support RFC 3339 time duration syntax
-** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approval(True) -> approve sending saved
-    + Approval(False) -> Close client connection immediately
-*** NeedsPassword(50) - Timeout, default disapprove
-    + SetPass(u"gazonk", True) -> Approval, persistent
-    + Approval(False) -> Close client connection immediately
-** TODO [#C] python-parsedatetime
-** TODO [#C] systemd/launchd
-   http://0pointer.de/blog/projects/systemd.html
-** TODO Separate logging logic to own object
-** TODO make clients to a dict!
+** TODO Persistent state
+   /var/lib/mandos/*
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
-   Remove mention of lack of such interface in BUGS section
-** Add mandos contact info in manual pages
 
-* TODO [#A] Provide and install /etc/dbus-1/system.d/mandos.conf
+* Provide and install /etc/dbus-1/system.d/mandos.conf
 
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Support RFC 3339 time duration syntax
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
   arguments.
 
 * mandos-monitor
+** D-Bus main loop w/ signal receiver
 ** Urwid client data displayer
-   Better view of client data in the listing
+*** Urwid scaffolding
+*** Client Widgets
 *** Properties popup
 
 * mandos-keygen
@@ -115,9 +97,7 @@
    For testing decryption before rebooting.
 
 * Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
-** TODO [#C] Implement DEB_BUILD_OPTIONS
+** Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 
 * Package
@@ -128,9 +108,5 @@
 ** TODO [#C] /etc/bash_completion.d/mandos
    From XML sources directly?
 
-* Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
-
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2009-12-25 23:13:47 +0000
+++ clients.conf	2009-01-08 03:54:06 +0000
@@ -2,15 +2,15 @@
 # values, so uncomment and change them if you want different ones.
 [DEFAULT]
 
-# How long until a client is disabled and not be allowed to get the
-# data this server holds.
+# How long until a client is considered invalid - that is, ineligible
+# to get the data this server holds.
 ;timeout = 1h
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
-# above "timeout" occurs, at which time the client will be disabled,
-# and any running checker killed.
+# above "timeout" occurs, at which time the client will be marked
+# invalid, and any running checker killed.
 ;interval = 5m
 
 # What command to run as "the checker".

=== modified file 'debian/control'
--- debian/control	2010-08-23 19:23:15 +0000
+++ debian/control	2009-09-17 01:21:27 +0000
@@ -15,8 +15,8 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid
+	python-avahi, python-gobject, avahi-daemon, gnupg (< 2),
+	adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -35,8 +35,7 @@
 
 Package: mandos-client
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2)
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/rules'
--- debian/rules	2009-11-11 00:25:22 +0000
+++ debian/rules	2009-11-01 00:10:28 +0000
@@ -15,18 +15,15 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
-# -pie was broken briefly on the mips and mipsel architectures, see
+# -pie is broken on the mips and mipsel architectures, see
 # <http://bugs.debian.org/526961>
-BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
-			--show binutils)
-ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
-		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
-		&& echo yes))
-  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
-		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
-    BROKEN_PIE := yes
-    export BROKEN_PIE
-  endif
+ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
+  BROKEN_PIE := yes
+  export BROKEN_PIE
+endif
+ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:))
+  BROKEN_PIE := yes
+  export BROKEN_PIE
 endif
 
 configure: configure-stamp

=== modified file 'mandos'
--- mandos	2010-09-02 18:36:36 +0000
+++ mandos	2009-11-05 02:12:57 +0000
@@ -55,12 +55,10 @@
 import logging
 import logging.handlers
 import pwd
-import contextlib
+from contextlib import closing
 import struct
 import fcntl
 import functools
-import cPickle as pickle
-import multiprocessing
 
 import dbus
 import dbus.service
@@ -83,7 +81,7 @@
 
 version = "1.0.14"
 
-logger = logging.getLogger(u'mandos')
+logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = "/dev/log"))
@@ -98,8 +96,6 @@
                                        u' %(message)s'))
 logger.addHandler(console)
 
-multiprocessing_manager = multiprocessing.Manager()
-
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -246,7 +242,7 @@
     enabled:    bool()
     last_checked_ok: datetime.datetime(); (UTC) or None
     timeout:    datetime.timedelta(); How long from last_checked_ok
-                                      until this client is disabled
+                                      until this client is invalid
     interval:   datetime.timedelta(); How often to start a new checker
     disable_hook:  If set, called by disable() as disable_hook(self)
     checker:    subprocess.Popen(); a running checker process used
@@ -260,9 +256,6 @@
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
     current_checker_command: string; current running checker_command
-    approved_delay: datetime.timedelta(); Time to wait for approval
-    _approved:   bool(); 'None' if not yet approved/disapproved
-    approved_duration: datetime.timedelta(); Duration of one approval
     """
     
     @staticmethod
@@ -279,9 +272,6 @@
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
         return self._timedelta_to_milliseconds(self.interval)
-
-    def approved_delay_milliseconds(self):
-        return self._timedelta_to_milliseconds(self.approved_delay)
     
     def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -300,12 +290,12 @@
         if u"secret" in config:
             self.secret = config[u"secret"].decode(u"base64")
         elif u"secfile" in config:
-            with open(os.path.expanduser(os.path.expandvars
-                                         (config[u"secfile"])),
-                      "rb") as secfile:
+            with closing(open(os.path.expanduser
+                              (os.path.expandvars
+                               (config[u"secfile"])),
+                              "rb")) as secfile:
                 self.secret = secfile.read()
         else:
-            #XXX Need to allow secret on demand!
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get(u"host", u"")
@@ -323,27 +313,12 @@
         self.checker_command = config[u"checker"]
         self.current_checker_command = None
         self.last_connect = None
-        self.approvals_pending = 0
-        self._approved = None
-        self.approved_by_default = config.get(u"approved_by_default",
-                                              True)
-        self.approved_delay = string_to_delta(
-            config[u"approved_delay"])
-        self.approved_duration = string_to_delta(
-            config[u"approved_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
-    def send_changedstate(self):
-        self.changedstate.acquire()
-        self.changedstate.notify_all()
-        self.changedstate.release()
-        
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, u"enabled", False):
             # Already enabled
             return
-        self.send_changedstate()
         self.last_enabled = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
@@ -363,8 +338,6 @@
         if not getattr(self, "enabled", False):
             return False
         if not quiet:
-            self.send_changedstate()
-        if not quiet:
             logger.info(u"Disabling client %s", self.name)
         if getattr(self, u"disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
@@ -423,8 +396,8 @@
         # client would inevitably timeout, since no checker would get
         # a chance to run to completion.  If we instead leave running
         # checkers alone, the checker would have to take more time
-        # than 'timeout' for the client to be disabled, which is as it
-        # should be.
+        # than 'timeout' for the client to be declared invalid, which
+        # is as it should be.
         
         # If a checker exists, make sure it is not a zombie
         try:
@@ -502,6 +475,17 @@
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
+    
+    def still_valid(self):
+        """Has the timeout not yet passed for this client?"""
+        if not getattr(self, u"enabled", False):
+            return False
+        now = datetime.datetime.utcnow()
+        if self.last_checked_ok is None:
+            return now < (self.created + self.timeout)
+        else:
+            return now < (self.last_checked_ok + self.timeout)
+
 
 def dbus_service_property(dbus_interface, signature=u"v",
                           access=u"readwrite", byte_arrays=False):
@@ -515,11 +499,6 @@
     dbus.service.method, except there is only "signature", since the
     type from Get() and the type sent to Set() is the same.
     """
-    # Encoding deeply encoded byte arrays is not supported yet by the
-    # "Set" method, so we fail early here:
-    if byte_arrays and signature != u"ay":
-        raise ValueError(u"Byte arrays not supported for non-'ay'"
-                         u" signature %r" % signature)
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -611,10 +590,6 @@
         if prop._dbus_access == u"read":
             raise DBusPropertyAccessException(property_name)
         if prop._dbus_get_args_options[u"byte_arrays"]:
-            # The byte_arrays option is not supported yet on
-            # signatures other than "ay".
-            if prop._dbus_signature != u"ay":
-                raise ValueError
             value = dbus.ByteArray(''.join(unichr(byte)
                                            for byte in value))
         prop(value)
@@ -702,7 +677,6 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
-        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
@@ -713,21 +687,6 @@
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
     
-    def _get_approvals_pending(value):
-        return self._approvals_pending
-    def _set_approvals_pending(value):
-        old_value = self._approvals_pending
-        self._approvals_pending = value
-        bval = bool(value)
-        if bval is bool(old_value):
-            dbus_bool = dbus.Boolean(bval, variant_level=1)
-            self.PropertyChanged(dbus.String(u"approved_pending"),
-                                 dbus_bool)
-        return value
-    approvals_pending = property(_get_approvals_pending,
-                                 _set_approvals_pending)
-    del _get_approvals_pending, _set_approvals_pending
-    
     @staticmethod
     def _datetime_to_dbus(dt, variant_level=0):
         """Convert a UTC datetime.datetime() to a D-Bus type."""
@@ -821,20 +780,14 @@
             self.PropertyChanged(dbus.String(u"checker_running"),
                                  dbus.Boolean(False, variant_level=1))
         return r
-
-    def _reset_approved(self):
-        self._approved = None
-        return False
-    
-    def approve(self, value=True):
-        self._approved = value
-        gobject.timeout_add(self._timedelta_to_milliseconds(self.approved_duration, self._reset_approved))
-    
-    
-    ## D-Bus methods, signals & properties
+    
+    ## D-Bus methods & signals
     _interface = u"se.bsnet.fukt.Mandos.Client"
     
-    ## Signals
+    # CheckedOK - method
+    @dbus.service.method(_interface)
+    def CheckedOK(self):
+        return self.checked_ok()
     
     # CheckerCompleted - signal
     @dbus.service.signal(_interface, signature=u"nxs")
@@ -861,28 +814,10 @@
         pass
     
     # Rejected - signal
-    @dbus.service.signal(_interface, signature=u"s")
-    def Rejected(self, reason):
-        "D-Bus signal"
-        pass
-    
-    # NeedApproval - signal
-    @dbus.service.signal(_interface, signature=u"db")
-    def NeedApproval(self, timeout, default):
-        "D-Bus signal"
-        pass
-    
-    ## Methods
-
-    # Approve - method
-    @dbus.service.method(_interface, in_signature=u"b")
-    def Approve(self, value):
-        self.approve(value)
-
-    # CheckedOK - method
-    @dbus.service.method(_interface)
-    def CheckedOK(self):
-        return self.checked_ok()
+    @dbus.service.signal(_interface)
+    def Rejected(self):
+        "D-Bus signal"
+        pass
     
     # Enable - method
     @dbus.service.method(_interface)
@@ -907,32 +842,6 @@
     def StopChecker(self):
         self.stop_checker()
     
-    ## Properties
-    
-    # approved_pending - property
-    @dbus_service_property(_interface, signature=u"b", access=u"read")
-    def approved_pending_dbus_property(self):
-        return dbus.Boolean(bool(self.approvals_pending))
-    
-    # approved_by_default - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
-    def approved_by_default_dbus_property(self):
-        return dbus.Boolean(self.approved_by_default)
-    
-    # approved_delay - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_delay_dbus_property(self):
-        return dbus.UInt64(self.approved_delay_milliseconds())
-    
-    # approved_duration - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_duration_dbus_property(self):
-        return dbus.UInt64(self._timedelta_to_milliseconds(
-                self.approved_duration))
-    
     # name - property
     @dbus_service_property(_interface, signature=u"s", access=u"read")
     def name_dbus_property(self):
@@ -1072,32 +981,6 @@
     del _interface
 
 
-class ProxyClient(object):
-    def __init__(self, child_pipe, fpr, address):
-        self._pipe = child_pipe
-        self._pipe.send(('init', fpr, address))
-        if not self._pipe.recv():
-            raise KeyError()
-
-    def __getattribute__(self, name):
-        if(name == '_pipe'):
-            return super(ProxyClient, self).__getattribute__(name)
-        self._pipe.send(('getattr', name))
-        data = self._pipe.recv()
-        if data[0] == 'data':
-            return data[1]
-        if data[0] == 'function':
-            def func(*args, **kwargs):
-                self._pipe.send(('funcall', name, args, kwargs))
-                return self._pipe.recv()[1]
-            return func
-
-    def __setattr__(self, name, value):
-        if(name == '_pipe'):
-            return super(ProxyClient, self).__setattr__(name, value)
-        self._pipe.send(('setattr', name, value))
-
-
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1105,22 +988,30 @@
     Note: This will run in its own forked process."""
     
     def handle(self):
-        with contextlib.closing(self.server.child_pipe) as child_pipe:
-            logger.info(u"TCP connection from: %s",
-                        unicode(self.client_address))
-            logger.debug(u"Pipe FD: %d",
-                         self.server.child_pipe.fileno())
-
+        logger.info(u"TCP connection from: %s",
+                    unicode(self.client_address))
+        logger.debug(u"IPC Pipe FD: %d", self.server.pipe[1])
+        # Open IPC pipe to parent process
+        with closing(os.fdopen(self.server.pipe[1], u"w", 1)) as ipc:
             session = (gnutls.connection
                        .ClientSession(self.request,
                                       gnutls.connection
                                       .X509Credentials()))
-
+            
+            line = self.request.makefile().readline()
+            logger.debug(u"Protocol version: %r", line)
+            try:
+                if int(line.strip().split()[0]) > 1:
+                    raise RuntimeError
+            except (ValueError, IndexError, RuntimeError), error:
+                logger.error(u"Unknown protocol version: %s", error)
+                return
+            
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
-
+            
             #priority = u':'.join((u"NONE", u"+VERS-TLS1.1",
             #                      u"+AES-256-CBC", u"+SHA1",
             #                      u"+COMP-NULL", u"+CTYPE-OPENPGP",
@@ -1132,19 +1023,7 @@
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
-
-            # Start communication using the Mandos protocol
-            # Get protocol number
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-
-            # Start GnuTLS connection
+            
             try:
                 session.handshake()
             except gnutls.errors.GNUTLSError, error:
@@ -1153,97 +1032,39 @@
                 # established.  Just abandon the request.
                 return
             logger.debug(u"Handshake succeeded")
-
-            approval_required = False
             try:
-                try:
-                    fpr = self.fingerprint(self.peer_certificate
-                                           (session))
-                except (TypeError, gnutls.errors.GNUTLSError), error:
-                    logger.warning(u"Bad certificate: %s", error)
-                    return
-                logger.debug(u"Fingerprint: %s", fpr)
-
-                try:
-                    client = ProxyClient(child_pipe, fpr,
-                                         self.client_address)
-                except KeyError:
-                    return
-                
-                if client.approved_delay:
-                    delay = client.approved_delay
-                    client.approvals_pending += 1
-                    approval_required = True
-                
-                while True:
-                    if not client.enabled:
-                        logger.warning(u"Client %s is disabled",
-                                       client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
-                        return
-                    
-                    if client._approved or not client.approved_delay:
-                        #We are approved or approval is disabled
-                        break
-                    elif client._approved is None:
-                        logger.info(u"Client %s need approval",
-                                    client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.NeedApproval(
-                                client.approved_delay_milliseconds(),
-                                client.approved_by_default)
-                    else:
-                        logger.warning(u"Client %s was not approved",
-                                       client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.Rejected("Disapproved")
-                        return
-                    
-                    #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
-                    time = datetime.datetime.now()
-                    client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
-                    client.changedstate.release()
-                    time2 = datetime.datetime.now()
-                    if (time2 - time) >= delay:
-                        if not client.approved_by_default:
-                            logger.warning("Client %s timed out while"
-                                           " waiting for approval",
-                                           client.name)
-                            if self.server.use_dbus:
-                                # Emit D-Bus signal
-                                client.Rejected("Time out")
-                            return
-                        else:
-                            break
-                    else:
-                        delay -= time2 - time
-                
-                sent_size = 0
-                while sent_size < len(client.secret):
-                    # XXX handle session exception
-                    sent = session.send(client.secret[sent_size:])
-                    logger.debug(u"Sent: %d, remaining: %d",
-                                 sent, len(client.secret)
-                                 - (sent_size + sent))
-                    sent_size += sent
-
-                logger.info(u"Sending secret to %s", client.name)
-                # bump the timeout as if seen
-                client.checked_ok()
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.GotSecret()
+                fpr = self.fingerprint(self.peer_certificate(session))
+            except (TypeError, gnutls.errors.GNUTLSError), error:
+                logger.warning(u"Bad certificate: %s", error)
+                session.bye()
+                return
+            logger.debug(u"Fingerprint: %s", fpr)
             
-            finally:
-                if approval_required:
-                    client.approvals_pending -= 1
-                session.bye()
+            for c in self.server.clients:
+                if c.fingerprint == fpr:
+                    client = c
+                    break
+            else:
+                ipc.write(u"NOTFOUND %s %s\n"
+                          % (fpr, unicode(self.client_address)))
+                session.bye()
+                return
+            # Have to check if client.still_valid(), since it is
+            # possible that the client timed out while establishing
+            # the GnuTLS session.
+            if not client.still_valid():
+                ipc.write(u"INVALID %s\n" % client.name)
+                session.bye()
+                return
+            ipc.write(u"SENDING %s\n" % client.name)
+            sent_size = 0
+            while sent_size < len(client.secret):
+                sent = session.send(client.secret[sent_size:])
+                logger.debug(u"Sent: %d, remaining: %d",
+                             sent, len(client.secret)
+                             - (sent_size + sent))
+                sent_size += sent
+            session.bye()
     
     @staticmethod
     def peer_certificate(session):
@@ -1309,37 +1130,24 @@
         return hex_fpr
 
 
-class MultiprocessingMixIn(object):
-    """Like socketserver.ThreadingMixIn, but with multiprocessing"""
-    def sub_process_main(self, request, address):
-        try:
-            self.finish_request(request, address)
-        except:
-            self.handle_error(request, address)
-        self.close_request(request)
-            
-    def process_request(self, request, address):
-        """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
-
-class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
-    """ adds a pipe to the MixIn """
+class ForkingMixInWithPipe(socketserver.ForkingMixIn, object):
+    """Like socketserver.ForkingMixIn, but also pass a pipe."""
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
         This function creates a new pipe in self.pipe
         """
-        parent_pipe, self.child_pipe = multiprocessing.Pipe()
-
-        super(MultiprocessingMixInWithPipe,
+        self.pipe = os.pipe()
+        super(ForkingMixInWithPipe,
               self).process_request(request, client_address)
-        self.add_pipe(parent_pipe)
-    def add_pipe(self, parent_pipe):
+        os.close(self.pipe[1])  # close write end
+        self.add_pipe(self.pipe[0])
+    def add_pipe(self, pipe):
         """Dummy function; override as necessary"""
-        pass
-
-class IPv6_TCPServer(MultiprocessingMixInWithPipe,
+        os.close(pipe)
+
+
+class IPv6_TCPServer(ForkingMixInWithPipe,
                      socketserver.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
     
@@ -1430,15 +1238,11 @@
             return socketserver.TCPServer.server_activate(self)
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+    def add_pipe(self, pipe):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(parent_pipe.fileno(),
-                             gobject.IO_IN | gobject.IO_HUP,
-                             functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
-    def handle_ipc(self, source, condition, parent_pipe=None,
-                   client_object=None):
+        gobject.io_add_watch(pipe, gobject.IO_IN | gobject.IO_HUP,
+                             self.handle_ipc)
+    def handle_ipc(self, source, condition, file_objects={}):
         condition_names = {
             gobject.IO_IN: u"IN",   # There is data to read.
             gobject.IO_OUT: u"OUT", # Data can be written (without
@@ -1456,54 +1260,57 @@
         logger.debug(u"Handling IPC: FD = %d, condition = %s", source,
                      conditions_string)
         
-        # Read a request from the child
-        request = parent_pipe.recv()
-        command = request[0]
+        # Turn the pipe file descriptor into a Python file object
+        if source not in file_objects:
+            file_objects[source] = os.fdopen(source, u"r", 1)
         
-        if command == 'init':
-            fpr = request[1]
-            address = request[2]
-            
-            for c in self.clients:
-                if c.fingerprint == fpr:
-                    client = c
-                    break
-            else:
-                logger.warning(u"Client not found for fingerprint: %s, ad"
-                               u"dress: %s", fpr, address)
-                if self.use_dbus:
-                    # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address)
-                parent_pipe.send(False)
-                return False
-            
-            gobject.io_add_watch(parent_pipe.fileno(),
-                                 gobject.IO_IN | gobject.IO_HUP,
-                                 functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
-            parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+        # Read a line from the file object
+        cmdline = file_objects[source].readline()
+        if not cmdline:             # Empty line means end of file
+            # close the IPC pipe
+            file_objects[source].close()
+            del file_objects[source]
+            
+            # Stop calling this function
             return False
-        if command == 'funcall':
-            funcname = request[1]
-            args = request[2]
-            kwargs = request[3]
-            
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
-
-        if command == 'getattr':
-            attrname = request[1]
-            if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
-            else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
-        
-        if command == 'setattr':
-            attrname = request[1]
-            value = request[2]
-            setattr(client_object, attrname, value)
-        
+        
+        logger.debug(u"IPC command: %r", cmdline)
+        
+        # Parse and act on command
+        cmd, args = cmdline.rstrip(u"\r\n").split(None, 1)
+        
+        if cmd == u"NOTFOUND":
+            logger.warning(u"Client not found for fingerprint: %s",
+                           args)
+            if self.use_dbus:
+                # Emit D-Bus signal
+                mandos_dbus_service.ClientNotFound(args)
+        elif cmd == u"INVALID":
+            for client in self.clients:
+                if client.name == args:
+                    logger.warning(u"Client %s is invalid", args)
+                    if self.use_dbus:
+                        # Emit D-Bus signal
+                        client.Rejected()
+                    break
+            else:
+                logger.error(u"Unknown client %s is invalid", args)
+        elif cmd == u"SENDING":
+            for client in self.clients:
+                if client.name == args:
+                    logger.info(u"Sending secret to %s", client.name)
+                    client.checked_ok()
+                    if self.use_dbus:
+                        # Emit D-Bus signal
+                        client.GotSecret()
+                    break
+            else:
+                logger.error(u"Sending secret to unknown client %s",
+                             args)
+        else:
+            logger.error(u"Unknown IPC command: %r", cmdline)
+        
+        # Keep calling this function
         return True
 
 
@@ -1560,7 +1367,7 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with contextlib.closing(socket.socket()) as s:
+            with closing(socket.socket()) as s:
                 ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
                                     struct.pack(str(u"16s16x"),
                                                 interface))
@@ -1697,8 +1504,6 @@
                         u"interval": u"5m",
                         u"checker": u"fping -q -- %%(host)s",
                         u"host": u"",
-                        u"approved_delay": u"0s",
-                        u"approved_duration": u"1s",
                         }
     client_config = configparser.SafeConfigParser(client_defaults)
     client_config.read(os.path.join(server_settings[u"configdir"],
@@ -1781,22 +1586,9 @@
     client_class = Client
     if use_dbus:
         client_class = functools.partial(ClientDBus, bus = bus)
-    def client_config_items(config, section):
-        special_settings = {
-            "approved_by_default":
-                lambda: config.getboolean(section,
-                                          "approved_by_default"),
-            }
-        for name, value in config.items(section):
-            try:
-                yield (name, special_settings[name]())
-            except KeyError:
-                yield (name, value)
-    
     tcp_server.clients.update(set(
             client_class(name = section,
-                         config= dict(client_config_items(
-                        client_config, section)))
+                         config= dict(client_config.items(section)))
             for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning(u"No clients defined")
@@ -1814,7 +1606,7 @@
         daemon()
     
     try:
-        with pidfile:
+        with closing(pidfile):
             pid = os.getpid()
             pidfile.write(str(pid) + "\n")
         del pidfile
@@ -1838,13 +1630,13 @@
                 dbus.service.Object.__init__(self, bus, u"/")
             _interface = u"se.bsnet.fukt.Mandos"
             
-            @dbus.service.signal(_interface, signature=u"o")
-            def ClientAdded(self, objpath):
+            @dbus.service.signal(_interface, signature=u"oa{sv}")
+            def ClientAdded(self, objpath, properties):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature=u"ss")
-            def ClientNotFound(self, fingerprint, address):
+            @dbus.service.signal(_interface, signature=u"s")
+            def ClientNotFound(self, fingerprint):
                 "D-Bus signal"
                 pass
             
@@ -1907,7 +1699,8 @@
     for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
-            mandos_dbus_service.ClientAdded(client.dbus_object_path)
+            mandos_dbus_service.ClientAdded(client.dbus_object_path,
+                                            client.GetAll(u""))
         client.enable()
     
     tcp_server.enable()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2009-12-25 23:13:47 +0000
+++ mandos-clients.conf.xml	2009-09-17 01:21:27 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2009-12-09">
+<!ENTITY TIMESTAMP "2009-09-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -63,8 +63,9 @@
       ><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>, read by it at startup.
       The file needs to list all clients that should be able to use
-      the service.  All clients listed will be regarded as enabled,
-      even if a client was disabled in a previous run of the server.
+      the service.  All clients listed will be regarded as valid, even
+      if a client was declared invalid in a previous run of the
+      server.
     </para>
     <para>
       The format starts with a <literal>[<replaceable>section
@@ -109,8 +110,9 @@
 	  <para>
 	    The timeout is how long the server will wait (for either a
 	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
+	    until a client is considered invalid - that is, ineligible
+	    to get the data this server holds.  By default Mandos will
+	    use 1 hour.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a
@@ -141,8 +143,8 @@
 	    not be started if an old one is still running.  The server
 	    will wait for a checker to complete until the above
 	    <quote><varname>timeout</varname></quote> occurs, at which
-	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
+	    time the client will be marked invalid, and any running
+	    checker killed.  The default interval is 5 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-12-26 01:19:47 +0000
+++ mandos-ctl	2009-10-26 21:16:16 +0000
@@ -24,7 +24,8 @@
     'last_enabled': u'Last Enabled',
     'checker': u'Checker',
     }
-defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok')
+defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
+                   'checker')
 domain = 'se.bsnet.fukt'
 busname = domain + '.Mandos'
 server_path = '/'
@@ -127,8 +128,8 @@
                   help="Start checker for client")
 parser.add_option("--stop-checker", action="store_true",
                   help="Stop checker for client")
-parser.add_option("-V", "--is-enabled", action="store_true",
-                  help="Check if client is enabled")
+parser.add_option("-V", "--is-valid", action="store_true",
+                  help="Check if client is still valid")
 parser.add_option("-r", "--remove", action="store_true",
                   help="Remove client")
 parser.add_option("-c", "--checker", type="string",
@@ -177,7 +178,7 @@
         client.StartChecker(dbus_interface=client_interface)
     if options.stop_checker:
         client.StopChecker(dbus_interface=client_interface)
-    if options.is_enabled:
+    if options.is_valid:
         sys.exit(0 if client.Get(client_interface,
                                  u"enabled",
                                  dbus_interface=dbus.PROPERTIES_IFACE)

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-11-19 18:31:28 +0000
+++ mandos-keygen	2009-10-26 21:16:16 +0000
@@ -278,7 +278,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir '"'$RINGDIR'"' --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-08-31 18:22:25 +0000
+++ mandos-monitor	2009-11-10 03:45:18 +0000
@@ -4,11 +4,8 @@
 from __future__ import division, absolute_import, with_statement
 
 import sys
-import os
 import signal
 
-import datetime
-
 import urwid.curses_display
 import urwid
 
@@ -19,18 +16,11 @@
 
 import UserList
 
-import locale
-
-locale.setlocale(locale.LC_ALL, u'')
-
-import logging
-logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
-
 # Some useful constants
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.15"
+version = "1.0.14"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -45,20 +35,26 @@
     properties and calls a hook function when any of them are
     changed.
     """
-    def __init__(self, proxy_object=None, *args, **kwargs):
+    def __init__(self, proxy_object=None, properties=None, *args,
+                 **kwargs):
         self.proxy = proxy_object # Mandos Client proxy object
         
-        self.properties = dict()
-        self.proxy.connect_to_signal(u"PropertyChanged",
+        if properties is None:
+            self.properties = dict()
+        else:
+            self.properties = properties
+        self.proxy.connect_to_signal("PropertyChanged",
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
         
-        self.properties.update(
-            self.proxy.GetAll(client_interface,
-                              dbus_interface = dbus.PROPERTIES_IFACE))
+        if properties is None:
+            self.properties.update(self.proxy.GetAll(client_interface,
+                                                     dbus_interface =
+                                                     dbus.PROPERTIES_IFACE))
         super(MandosClientPropertyCache, self).__init__(
-            proxy_object=proxy_object, *args, **kwargs)
+            proxy_object=proxy_object,
+            properties=properties, *args, **kwargs)
     
     def property_changed(self, property=None, value=None):
         """This is called whenever we get a PropertyChanged signal
@@ -73,90 +69,23 @@
     """
     
     def __init__(self, server_proxy_object=None, update_hook=None,
-                 delete_hook=None, logger=None, *args, **kwargs):
+                 delete_hook=None, *args, **kwargs):
         # Called on update
         self.update_hook = update_hook
         # Called on delete
         self.delete_hook = delete_hook
         # Mandos Server proxy object
         self.server_proxy_object = server_proxy_object
-        # Logger
-        self.logger = logger
         
         # The widget shown normally
-        self._text_widget = urwid.Text(u"")
+        self._text_widget = urwid.Text("")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text(u"")
+        self._focus_text_widget = urwid.Text("")
         super(MandosClientWidget, self).__init__(
             update_hook=update_hook, delete_hook=delete_hook,
             *args, **kwargs)
         self.update()
         self.opened = False
-        self.proxy.connect_to_signal(u"CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
-    
-    def checker_completed(self, exitstatus, condition, command):
-        if exitstatus == 0:
-            #self.logger(u'Checker for client %s (command "%s")'
-            #            u' was successful'
-            #            % (self.properties[u"name"], command))
-            return
-        if os.WIFEXITED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' failed with exit code %s'
-                        % (self.properties[u"name"], command,
-                           os.WEXITSTATUS(condition)))
-            return
-        if os.WIFSIGNALED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was killed by signal %s'
-                        % (self.properties[u"name"], command,
-                           os.WTERMSIG(condition)))
-            return
-        if os.WCOREDUMP(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' dumped core'
-                        % (self.properties[u"name"], command))
-        self.logger(u'Checker for client %s completed mysteriously')
-    
-    def checker_started(self, command):
-        #self.logger(u'Client %s started checker "%s"'
-        #            % (self.properties[u"name"], unicode(command)))
-        pass
-    
-    def got_secret(self):
-        self.logger(u'Client %s received its secret'
-                    % self.properties[u"name"])
-    
-    def need_approval(self, timeout, default):
-        if not default:
-            message = u'Client %s needs approval within %s seconds'
-        else:
-            message = u'Client %s will get its secret in %s seconds'
-        self.logger(message
-                    % (self.properties[u"name"], timeout/1000))
-    
-    def rejected(self, reason):
-        self.logger(u'Client %s was rejected; reason: %s'
-                    % (self.properties[u"name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
@@ -186,15 +115,11 @@
                           }
         
         # Rebuild focus and non-focus widgets using current properties
-        self._text = (u'%(name)s: %(enabled)s'
-                      % { u"name": self.properties[u"name"],
-                          u"enabled":
-                              (u"enabled"
-                               if self.properties[u"enabled"]
-                               else u"DISABLED")})
+        self._text = (u'name="%(name)s", enabled=%(enabled)s'
+                      % self.properties)
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [(u"normal", self._text)]
+        textlist = [(u"normal", u"BLARGH: "), (u"bold", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -225,7 +150,7 @@
             self.proxy.Enable()
         elif key == u"d" or key == u"-":
             self.proxy.Disable()
-        elif key == u"r" or key == u"_" or key == u"ctrl k":
+        elif key == u"r" or key == u"_":
             self.server_proxy_object.RemoveClient(self.proxy
                                                   .object_path)
         elif key == u"s":
@@ -241,10 +166,6 @@
 #             self.proxy.unpause()
 #         elif key == u"RET":
 #             self.open()
-        elif key == u"+":
-            self.proxy.Approve(True)
-        elif key == u"-":
-            self.proxy.Approve(False)
         else:
             return key
     
@@ -302,8 +223,8 @@
                 ))
         
         if urwid.supports_unicode():
-            self.divider = u"─" # \u2500
-            #self.divider = u"━" # \u2501
+            #self.divider = u"─" # \u2500
+            self.divider = u"━" # \u2501
         else:
             #self.divider = u"-" # \u002d
             self.divider = u"_" # \u005f
@@ -329,10 +250,10 @@
         self.log_wrap = u"any"
         
         self.rebuild()
-        self.log_message_raw((u"bold",
-                              u"Mandos Monitor version " + version))
-        self.log_message_raw((u"bold",
-                              u"q: Quit  ?: Help"))
+        self.log_message((u"bold",
+                          u"Mandos Monitor version " + version))
+        self.log_message((u"bold",
+                          u"q: Quit  ?: Help"))
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
@@ -349,20 +270,15 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal(u"ClientRemoved",
+         .connect_to_signal("ClientRemoved",
                             self.find_and_remove_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal(u"ClientAdded",
+         .connect_to_signal("ClientAdded",
                             self.add_new_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal(u"ClientNotFound",
-                            self.client_not_found,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
         for path, client in mandos_clients.iteritems():
             client_proxy_object = self.bus.get_object(self.busname,
                                                       path)
@@ -374,16 +290,9 @@
                                                update_hook
                                                =self.refresh,
                                                delete_hook
-                                               =self.remove_client,
-                                               logger
-                                               =self.log_message),
+                                               =self.remove_client),
                             path=path)
     
-    def client_not_found(self, fingerprint, address):
-        self.log_message((u"Client with address %s and fingerprint %s"
-                          u" could not be found" % (address,
-                                                    fingerprint)))
-    
     def rebuild(self):
         """This rebuilds the User Interface.
         Call this when the widget layout needs to change"""
@@ -398,19 +307,12 @@
             pass
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message):
-        timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + u": " + message)
-    
-    def log_message_raw(self, markup):
+    def log_message(self, markup):
         """Add a log message to the log buffer."""
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
             del self.log[0:len(self.log)-self.max_log_length-1]
-        self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from=u"above")
-        self.refresh()
     
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
@@ -442,18 +344,17 @@
             return
         self.remove_client(client, path)
     
-    def add_new_client(self, path):
+    def add_new_client(self, path, properties):
         client_proxy_object = self.bus.get_object(self.busname, path)
         self.add_client(MandosClientWidget(server_proxy_object
                                            =self.mandos_serv,
                                            proxy_object
                                            =client_proxy_object,
+                                           properties=properties,
                                            update_hook
                                            =self.refresh,
                                            delete_hook
-                                           =self.remove_client,
-                                           logger
-                                           =self.log_message),
+                                           =self.remove_client),
                         path=path)
     
     def add_client(self, client, path=None):
@@ -528,26 +429,24 @@
             elif key == u"w" or key == u"i":
                 self.change_log_display()
                 self.refresh()
-            elif key == u"?" or key == u"f1" or key == u"esc":
+            elif key == u"?" or key == u"f1":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw((u"bold",
-                                      u"  ".
-                                      join((u"q: Quit",
-                                            u"?: Help",
-                                            u"l: Log window toggle",
-                                            u"TAB: Switch window",
-                                            u"w: Wrap (log)"))))
-                self.log_message_raw((u"bold",
-                                      u"  "
-                                      .join((u"Clients:",
-                                             u"e: Enable",
-                                             u"d: Disable",
-                                             u"r: Remove",
-                                             u"s: Start new checker",
-                                             u"S: Stop checker",
-                                             u"C: Checker OK"))))
+                self.log_message((u"bold",
+                                  u"  ".join((u"q: Quit",
+                                              u"?: Help",
+                                              u"l: Log window toggle",
+                                              u"TAB: Switch window",
+                                              u"w: Wrap (log)"))))
+                self.log_message((u"bold",
+                                  u"  ".join((u"Clients:",
+                                              u"e: Enable",
+                                              u"d: Disable",
+                                              u"r: Remove",
+                                              u"s: Start new checker",
+                                              u"S: Stop checker",
+                                              u"C: Checker OK"))))
                 self.refresh()
             elif key == u"tab":
                 if self.topwidget.get_focus() is self.logbox:
@@ -581,7 +480,6 @@
 ui = UserInterface()
 try:
     ui.run()
-except Exception, e:
-    ui.log_message(unicode(e))
+except:
     ui.screen.stop()
     raise

=== modified file 'mandos.xml'
--- mandos.xml	2009-12-25 23:13:47 +0000
+++ mandos.xml	2009-09-17 01:21:27 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-12-09">
+<!ENTITY TIMESTAMP "2009-09-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -453,9 +453,10 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
-      Currently, if a client is disabled due to having timed out, the
-      server does not record this fact onto permanent storage.  This
-      has some security implications, see <xref linkend="clients"/>.
+      Currently, if a client is declared <quote>invalid</quote> due to
+      having timed out, the server does not record this fact onto
+      permanent storage.  This has some security implications, see
+      <xref linkend="clients"/>.
     </para>
     <para>
       There is currently no way of querying the server of the current
@@ -548,18 +549,19 @@
       </para>
       <para>
 	If a client is compromised, its downtime should be duly noted
-	by the server which would therefore disable the client.  But
-	if the server was ever restarted, it would re-read its client
-	list from its configuration file and again regard all clients
-	therein as enabled, and hence eligible to receive their
-	passwords.  Therefore, be careful when restarting servers if
-	it is suspected that a client has, in fact, been compromised
-	by parties who may now be running a fake Mandos client with
-	the keys from the non-encrypted initial <acronym>RAM</acronym>
-	image of the client host.  What should be done in that case
-	(if restarting the server program really is necessary) is to
-	stop the server program, edit the configuration file to omit
-	any suspect clients, and restart the server program.
+	by the server which would therefore declare the client
+	invalid.  But if the server was ever restarted, it would
+	re-read its client list from its configuration file and again
+	regard all clients therein as valid, and hence eligible to
+	receive their passwords.  Therefore, be careful when
+	restarting servers if it is suspected that a client has, in
+	fact, been compromised by parties who may now be running a
+	fake Mandos client with the keys from the non-encrypted
+	initial <acronym>RAM</acronym> image of the client host.  What
+	should be done in that case (if restarting the server program
+	really is necessary) is to stop the server program, edit the
+	configuration file to omit any suspect clients, and restart
+	the server program.
       </para>
       <para>
 	For more details on client-side security, see

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-03-27 18:39:02 +0000
+++ plugin-runner.c	2009-11-05 01:59:51 +0000
@@ -54,7 +54,7 @@
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
 				   FD_CLOEXEC */
 #include <string.h>		/* strsep, strlen(), asprintf(),
-				   strsignal(), strcmp(), strncmp() */
+				   strsignal() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -844,7 +844,7 @@
       for(const char **suf = bad_suffixes; *suf != NULL; suf++){
 	size_t suf_len = strlen(*suf);
 	if((d_name_len >= suf_len)
-	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
+	   and (strcmp((dirst->d_name)+d_name_len-suf_len, *suf)
 		== 0)){
 	  if(debug){
 	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-03-27 18:39:02 +0000
+++ plugins.d/password-prompt.c	2009-10-30 16:23:43 +0000
@@ -46,7 +46,7 @@
 				*/
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex */
+#include <string.h> 		/* strlen, rindex, strncmp, strcmp */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-05-18 16:56:54 +0000
+++ plugins.d/usplash.c	2009-10-30 16:22:31 +0000
@@ -607,10 +607,6 @@
     
     setsid();
     ret = chdir("/");
-    if(ret == -1){
-      perror("chdir");
-      _exit(EX_OSERR);
-    }
 /*     if(fork() != 0){ */
 /*       _exit(EXIT_SUCCESS); */
 /*     } */

